(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@analytics/segment'), require('lodash/template')) :
    typeof define === 'function' && define.amd ? define(['exports', '@analytics/segment', 'lodash/template'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.Segment = {}, global.segment, global.template));
})(this, (function (exports, segment, template) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var segment__default = /*#__PURE__*/_interopDefaultLegacy(segment);
    var template__default = /*#__PURE__*/_interopDefaultLegacy(template);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    // const merge = (instance) => {
    //   const isMerged = instance.storage.getItem(SEGMENT_MERGED_FLAG);
    //   if (isMerged) {
    //     return;
    //   }
    //   const segmentUserId = instance.storage.getItem('ajs_anonymous_id');
    //   if (segmentUserId) {
    //     instance.identify(segmentUserId);
    //     instance.storage.setItem(SEGMENT_MERGED_FLAG, 'true');
    //   }
    // };
    // export const NinetailedSegmentPlugin = (): AnalyticsPlugin => {
    //   return {
    //     name: 'ninetailed:segment',
    //     config: {},
    //     initialize: ({ instance }) => {
    //       merge(instance);
    //     },
    //     pageStart: ({ instance }) => {
    //       merge(instance);
    //     },
    //     trackStart: ({ instance }) => {
    //       merge(instance);
    //     },
    //     identifyStart: ({ instance }) => {
    //       merge(instance);
    //     },
    //     loaded: () => true,
    //   };
    // };

    var HAS_SEEN_COMPONENT = 'hasSeenComponent';
    var TEMPLATE_OPTIONS = {
      interpolate: /{{([\s\S]+?)}}/g
    };
    var NinetailedSegmentPlugin = function NinetailedSegmentPlugin(options) {
      var actionTemplate = template__default["default"](options.actionTemplate || 'Has Seen Component - Audience:{{ audience.id }}', TEMPLATE_OPTIONS);
      var trackOverwritePlugin = {
        name: 'ninetailed:segment',
        'page:segment': function (_a) {
          var abort = _a.abort;
          return abort();
        },
        'track:segment': function (_a) {
          var payload = _a.payload,
              abort = _a.abort;
          var event = payload.event,
              properties = payload.properties;

          if (event !== HAS_SEEN_COMPONENT || !properties || !properties.variant || !properties.audience || typeof properties.isPersonalized === 'undefined') {
            return abort();
          }

          var variant = properties.variant,
              audience = properties.audience,
              isPersonalized = properties.isPersonalized;
          var action = actionTemplate({
            component: variant,
            audience: audience
          });
          return __assign(__assign({}, payload), {
            event: action,
            properties: {
              category: 'Ninetailed',
              component: variant.id,
              audience: audience.id,
              isPersonalized: isPersonalized
            }
          });
        },
        'identify:segment': function (_a) {
          var abort = _a.abort;
          return abort();
        }
      };
      return [trackOverwritePlugin, segment__default["default"]({
        writeKey: options.writeKey
      })];
    };

    exports.NinetailedSegmentPlugin = NinetailedSegmentPlugin;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
